<?php

namespace App\Models;

use Backpack\CRUD\app\Models\Traits\CrudTrait;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\Auth;
use Ramsey\Uuid\Guid\Fields;

/**
 * @property mixed $started_at
 * @property int $package_id
 * @property mixed $ended_at
 * @property mixed $birthday
 */
class Student extends Model
{
    use CrudTrait;
    use HasFactory;
    use SoftDeletes;

    const INVOICE_SENT_STATUS = 'invoice_sent'; # Đã gửi hoá đơn
    const INVOICE_RENEW_STATUS = 'invoice_renew'; # Đã thanh toán
    const STATUS_CUSTOMER = 0; # Khách hàng
    const STATUS_LEARNING = 1;
    const STATUS_STOP = 2;
    const STATUS_ARCHIVED = 3;
    const INVOICE_PAYMENT_STATUS = 3;
    const EXPERIENCED = 9;
    const UNPAID_AMOUNT_REMAINING = 10;

    public static function invoiceStatusOptions()
    {
        return [
            self::INVOICE_SENT_STATUS => __('app.label.student.invoice_status_options.invoice_sent'),
            self::INVOICE_RENEW_STATUS => __('app.label.student.status_options.invoice_renew'),
        ];
    }

    protected static function boot()
    {
        parent::boot(); // TODO: Change the autogenerated stub
        static::addGlobalScope('branch', function ($builder) {
            if (backpack_user()) {
                $builder->where('branch', backpack_user()->branch);
            }
        });
    }

    private int $update_ended_at = 0;
    protected $guarded = ['id'];
    protected $appends = [
        'has_new_log'
    ];

    public function Renews(): HasMany
    {
        return $this->hasMany(Renew::class, 'student_id')->where('package_id', $this->package_id);
    }

    public function Classroom(): BelongsTo
    {
        return $this->belongsTo(Classroom::class, 'classroom_id', 'id');
    }

    public function Package(): BelongsTo
    {
        return $this->belongsTo(Package::class, 'package_id', 'id');
    }

    public function Invoices(): HasMany
    {
        return $this->hasMany(Invoice::class, 'student_id');
    }

    public function unPaidAmount(): int
    {
        $paid = $this->Invoices()->where('package_id', $this->package_id)->sum('amount');

        return ($this->Package()?->first()?->original_fee) * ($this->Renews()->count() + 1) - $paid ?? 0;
    }

    public static function statusOptions(): array
    {
        return [
            self::STATUS_CUSTOMER => __('app.label.student.status_options.customer'),
            self::STATUS_LEARNING => __('app.label.student.status_options.learning'),
            self::STATUS_STOP => __('app.label.student.status_options.stop'),
            self::STATUS_ARCHIVED => __('app.label.student.status_options.archived'),
        ];
    }

    public function setAvatarAttribute($value): void
    {
        if (!$value) {
            $this->attributes['avatar'] = 'https://cdn.pixabay.com/photo/2015/10/05/22/37/blank-profile-picture-973460_640.png';
        }
    }

    public function setEndedAtAttribute(): void
    {
        if ($this->package_id && !$this->ended_at) {
            $package = $this->Package()->first();

            if ($package && $this->started_at) {
                $endedAt = Carbon::parse($this->started_at)->addWeeks($package->original_weeks);

                $this->attributes['ended_at'] = $endedAt;
            }
        }
    }

    public function setStatusAttribute($value): void
    {
        if (!$value && backpack_user()->{'role'} == User::ROLE_STAFF) {
            $this->attributes['status'] = self::STATUS_CUSTOMER;

            return;
        }

        $this->attributes['status'] = $value;
    }

    public function getDetailBirthdayAttribute(): string
    {
        if (!($this->attributes['birthday'] ?? null)) {
            return '';
        }

        return Carbon::parse($this->attributes['birthday'])->isoFormat('DD-MM-YYYY');
    }

    public function getDetailStartedAtAttribute(): string
    {
        if (!($this->attributes['started_at'] ?? null)) {
            return '';
        }

        return Carbon::parse($this->attributes['started_at'])->isoFormat('DD-MM-YYYY');
    }

    public function getDetailEndedAtAttribute(): string
    {
        if (!($this->attributes['ended_at'] ?? null)) {
            return '';
        }

        return Carbon::parse($this->attributes['ended_at'])->isoFormat('DD-MM-YYYY');
    }

    public function getDetailRegisterAtAttribute(): string
    {
        if (!($this->attributes['register_at'] ?? null)) {
            return '';
        }

        return Carbon::parse($this->attributes['register_at'])->isoFormat('DD-MM-YYYY');
    }

    public function getDetailRemainingDay(): string
    {
        $end = $this->attributes['ended_at'] ?? null;

        if (!$end) {
            return 0;
        }

        $diffDay = Carbon::parse($this->attributes['ended_at'])->diffInDays(Carbon::now()) + 1;

        if (Carbon::parse($this->attributes['ended_at']) < Carbon::now()) {
            return -$diffDay;
        }

        return $diffDay;
    }

    public function getRemainingTextColor(): string
    {
        if ($this->getDetailRemainingDay() > 7) {
            return 'text-success';
        }

        if ($this->getDetailRemainingDay() > 0) {
            return 'text-warning';
        }


        return 'text-danger';
    }

    public function getRenewLabelAttribute(): string
    {
        return "Tên HS: " . $this->name . ' | Ngày kết thúc gói: ' . Carbon::parse($this->ended_at)->isoFormat('DD-MM-YYYY');
    }

    public function setBranchAttribute()
    {
        $this->attributes['branch'] = backpack_user()->branch;
    }

    protected $casts = [
        'create_invoices' => 'array'
    ];

    public function StudentLogs()
    {
        return $this->hasMany(StudentLog::class, 'student_id');
    }

    public function getHasNewLogAttribute(): bool
    {
        return $this->StudentLogs()->where('confirmed', 0)->count();
    }

    public function getPaymentDateTextColor()
    {
        $end = $this->attributes['payment_date'] ?? null;
        if (!$end) {
            return 0;
        }

        $paymentDateRemaining = Carbon::parse($this->attributes['payment_date'])->diffInDays(Carbon::now()) + 1;

        if ($paymentDateRemaining > 7) {
            return 'text-success';
        }

        if ($paymentDateRemaining > 0) {
            return 'text-danger';
        }

        return 'text-success';
    }
}
